<?php

/**
 * proceso_coactivo actions.
 *
 * @package    cobro_coactivo
 * @subpackage proceso_coactivo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class proceso_coactivoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_PROCESO_COACTIVO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_PROCESO_COACTIVO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha',
            'id_anhos' => 'id_anhos'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_remision',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'no_proceso'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_proceso_coactivo,a' => array('!=' => array(-1)),
            'id_proceso_coactivo,b' => array('=' => array('id_proceso_coactivo')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'no_proceso' => array('=' => array('no_proceso')),
            'id_anhos' => array('=' => array('id_anhos')),
            'fecha' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_proceso_coactivo'; //identificador de la tabla
    protected $id_names = array('id_proceso_coactivo'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'no_proceso', 'fecha', 'id_anhos'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_PROCESO_COACTIVO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_proceso_coactivo'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $sql = <<<EOD
select consecutivo from cbr_consecutivo_proc where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Se coloca validacion sino existe consecutivo por año - 20170113
            if (count($records) > 0) {

                $consecutivo = $records[0]['consecutivo'];

                $request['no_proceso'] = $consecutivo;
                $request['id_anhos'] = $id_anhos;

                $sql = <<<EOD
update cbr_consecutivo_proc set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                CN_TABLE::executeSQL($sql);
            } else {

                $consecutivo = 1;

                $request['no_proceso'] = $consecutivo;
                $request['id_anhos'] = $id_anhos;

                $sql = <<<EOD
Insert into CBR_CONSECUTIVO_PROC (ID_CONSECUTIVO_PROC,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos', $consecutivo+1 ) 
EOD;

                CN_TABLE::executeSQL($sql);
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
